package io.demo

import arrow.continuations.SuspendApp
import arrow.continuations.ktor.server
import arrow.fx.coroutines.resourceScope
import io.ktor.server.application.call
import io.ktor.server.netty.Netty
import io.ktor.server.response.respond
import io.ktor.server.routing.get
import io.ktor.server.routing.routing
import kotlin.time.Duration.Companion.milliseconds
import kotlinx.coroutines.awaitCancellation

fun main(): Unit = SuspendApp {
    resourceScope {
        server(
            Netty,
            preWait = 10000.milliseconds,
        ) {
            routing {
                get("/ping") {
                    call.respond("pong")
                }
            }
        }

        awaitCancellation()
    }
}
